import processing.pdf.*;
import java.util.Calendar;
import java.util.List;

class DropNode {

  float x;
  float y;
  float r;
  
  float v = 1;
  
  float red = 30 + random(60);
  float green = 0;
  float blue = 0;
  
  int life = 1;
  boolean falling = true;
  
  DropNode(float x, float y, float r) {
    this.x = x;
    this.y = y;
    this.r = r;
    
    if (this.r < 6) {
      falling = true;
    }
    
    blue = cos(x)*sin(y)*50;
  }
  
    void tick() {
      y += v;
      v *= 1.04;
  }
  
  void draw() {
    fill(red, green, blue);
    stroke(red, green, blue);
    ellipse(x, y, r*2, r*2);
  }
  
}

boolean savePDF = false;

int maxCount = 5000; //max count of the cirlces
int currentCount = 1;
List<DropNode> dropNodes = new ArrayList<DropNode>();

void setup() {
  size(1000, 1000);
  smooth();
  frameRate(1000);
}


void draw() {
  if (savePDF) beginRecord(PDF, timestamp()+".pdf");
  background(0);

  strokeWeight(10);
  
  float ox = 0;
  float oy = height/2;
  for (int x = 1; x < width; ++x) {
    stroke(((float)x / width) * 255, 50, 255 - ((float)x / width) * 255);
    line(ox, oy, x, height/2 + sin(x/10+frameCount/99.0)*100*(1000/x));
    ox = x;
    oy = height/2 + sin(x/10+frameCount/99.0)*100*(1000/x);
  }

  if (savePDF) {
    savePDF = false;
    endRecord();
  }
}

void keyReleased() {
  if (key == 's' || key == 'S') saveFrame(timestamp()+"_##.png");
  if (key == 'p' || key == 'P') savePDF = true;
}

// timestamp
String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}